const { MessageEmbed, MessageAttachment } = require("discord.js")
const Canvas = require('canvas')

class Captcha {
    constructor(options = {}) {
        let chars = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
            'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd',
            'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's',
            't', 'u', 'v', 'w', 'x', 'y', 'z', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9];
        let code = '';
        for (var i = 0; i < 6; i++) {
            code += chars[Math.floor(Math.random() * chars.length)];
        }
        const canvas = Canvas.createCanvas(600, 200)
        const ctx = canvas.getContext('2d')
        const background = await Canvas.loadImage(__dirname + "/background.png")
        ctx.drawImage(background, 0, 0, canvas.width, canvas.height) // Setting BackGround Image
        ctx.strokeStyle = '#FFFFFF'

        ctx.strokeRect(0, 0, canvas.width, canvas.height)
        this._canvas = {
            canvas: canvas,
            ctx: ctx
        }
        this._text = code;
    }
    text() {
        return this._text;
    }
    image() {
        var text = this._text;
        var ctx = this._canvas.ctx;
        var canvas = this._canvas.canvas;
        ctx.font = 'bold 60px Sans'  // Defining Size, Font
        ctx.fillStyle = '#21FBA1' // Keep Color Of Discriminator
        ctx.fillText(text, 0, 0);
        const attachment = new MessageAttachment(canvas.toBuffer(), 'captcha.png');
        return attachment;
    }
}

module.exports = Captcha;